import QUB
from Buttons import *
from Dialogs import *
from qubtree import Node
import math
from itertools import *

def children(tree, name=None):
    if name == None:
        child = tree.child
    else:
        child = tree.find(name)
    while not child.isNull:
        yield child
        if name == None:
            child = child.sibling
        else:
            child = child.nextSameName()


def IdlToList(settings):
    list_cls = settings['cls'] - 1
    list_nm = settings['nm']
    list_pairs = []
    idl = QUB.getChosenIdealization()
    for seg in children(idl.find('DataSet'), 'Segment'):
        firsts  = seg['Firsts'].data
        lasts   = seg['Lasts'].data
        classes = seg['Classes'].data
        count   = seg['DwellCount'].data[0]
        for i in range(count):
            if classes[i] == list_cls:
                list_pairs.append( (firsts[i], lasts[i]) )
    QUB.DataView.currData.setList(list_nm, list_pairs)

AddTaskButton( 'Idl->Lst', # button text
               IdlToList,   # function
               'I2Lst',       # short text for small buttons
               1,            # show settings dialog on left-click?
               1,            # show settings dialog on right-click?
               "Make a selection list of all datapoints from one idealized class",   # tool-tip
               "Make a selection list of all datapoints from one idealized class",   # description in "Edit Buttons"
               "Idl->Lst properties:", # caption for the settings dialog
               [DialogText("cls", "Class (1 is closed):", 2, acceptIntGreaterThan(0)),
                DialogText("nm", "Output list name:", "Idl")],
               'Preprocessing', DataChannel=True, DataList=True)
    